#****************************************************************************
#*                          CallbackTypes.tcl
#*
#* Author: Matthew Ballance
#* Desc:   Defines global variables for the basic IVI-defined callbacks
#* <Copyright> (c) 2001-2003 Matthew Ballance (mballance@users.sourceforge.net)
#*
#*    This source code is free software; you can redistribute it
#*    and/or modify it in source code form under the terms of the GNU
#*    General Public License as published by the Free Software
#*    Foundation; either version 2 of the License, or (at your option)
#*    any later version.
#*
#*    This program is distributed in the hope that it will be useful,
#*    but WITHOUT ANY WARRANTY; without even the implied warranty of
#*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#*    GNU General Public License for more details.
#*
#*    You should have received a copy of the GNU General Public License
#*    along with this program; if not, write to the Free Software
#*    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
#*
#* </Copyright>
#****************************************************************************

uplevel #0 {
    set CallbackTypes(SDBR_SIGLIST_UPDATE)       "SDBR.SigListUpdate"
    set CallbackTypes(SDBR_SIGDATA_UPDATE)       "SDBR.SigDataUpdate"
    set CallbackTypes(SDB_SIGDATA_UPDATE)        "SDB.SigDataUpdate"
    set CallbackTypes(SDB_MGR_UPDATE)            "SDB.MgrUpdate"
    set CallbackTypes(SIM_RUNSTEP_START)         "Sim.RunStepStart"
    set CallbackTypes(SIM_RUNSTEP_UPDATE)        "Sim.RunStepUpdate"
    set CallbackTypes(SIM_RUNSTEP_START)         "Sim.RunStepStart"
    set CallbackTypes(SIM_RUNSTEP_UPDATE)        "Sim.RunStepUpdate"
    set CallbackTypes(SIM_RUNSTEP_END)           "Sim.RunStepEnd"
    set CallbackTypes(SIM_DESIGN_LOAD)           "Sim.DesignLoad"
    set CallbackTypes(SIM_DESIGN_CLOSE)          "Sim.DesignClose"
    set CallbackTypes(DDB_UPDATE)                "DDB.Update"
    set CallbackTypes(CBTYPE_X_BUTTON_PRESS)     "X.ButtonPress"
    set CallbackTypes(CBTYPE_X_BUTTON_RELEASE)   "X.ButtonRelease"
    set CallbackTypes(CBTYPE_X_MOTION)           "X.MotionNotify"

    set CallbackTypes(CBTYPE_APP_CONSTRUCT)      "App.Register"
    set CallbackTypes(CBTYPE_APP_CONSTRUCT)      "App.Construct"

    set CallbackTypes(CBTYPE_STIM_SEQ_LST_UPDATE) "StimMgr.StimSeqListUpdate"

    set CallbackTypes(CBTYPE_CURSOR_LIST_UPDATE)  "CursorMgr.CursorListUpdate"
}

